﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.JavaScript.DataVisualization.Models.Diagram;
using Syncfusion.JavaScript.DataVisualization.Models.Collections;
using Syncfusion.JavaScript.DataVisualization.Models;
using Syncfusion.JavaScript.DataVisualization.DiagramEnums;
using Label = Syncfusion.JavaScript.DataVisualization.Models.Diagram.Label;

namespace WebApplication2
{
    public partial class BPMNShapes : System.Web.UI.Page
    {
        string darkColor = "#C7D4DF";
        string lightColor = "#f5f5f5";
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {

                dgrMap.PageSettings.PageHeight = 600;
                dgrMap.PageSettings.PageWidth = 600;
                dgrMap.PageSettings.MultiplePage = true;
                GenerateDiagram();
            }
        }
        public void GenerateDiagram()
        {
            dgrMap.Height = "100%";
            dgrMap.Width = "100%";
            dgrMap.SelectorConstraints = SelectorConstraints.All ^ SelectorConstraints.Rotator;
            GenerateDiagramNodes();
            GenerateDiagramConnectors();
        }
        private void GenerateDiagramNodes()
        {
            SwimLane swimlane = new SwimLane();
            swimlane.Type = "swimlane";
            swimlane.Name = "swimlane";
            Header header = new Header();
            header.Text = "ONLINE PURCHASE STATUS";
            header.Height = 50;
            header.FillColor = darkColor;
            header.FontSize = 11;
            swimlane.Header = header;
            swimlane.FillColor = darkColor;
            swimlane.Orientation = "horizontal";
            swimlane.OffsetX = 350;
            swimlane.OffsetY = 290;
            swimlane.Height = 100;
            swimlane.Width = 650;
            swimlane.Lanes = CreateLanes();
            swimlane.Phases = CreatePhases();
            dgrMap.Model.Nodes.Add(swimlane);
        }
        private Collection CreateLanes()
        {
            Collection laneCollection = new Collection();

            Collection childCollec = new Collection();
            childCollec.Add(CreateDiagramNode("Order", 100, 40, "white", "ORDER", 70, 1, true));
            laneCollection.Add(CreateLane("stackCanvas1", "CUSTOMER", 50, lightColor, 120, childCollec));

            childCollec = new Collection();
            childCollec.Add(CreateDiagramNode("selectItemaddcart", 100, 40, "white", "Select item\\nAdd cart", 190, 20, false));
            childCollec.Add(CreateDiagramNode("paymentondebitcreditcard", 100, 40, "white", "Payment on\\nDebit\\Credit Card", 350, 20, false));
            laneCollection.Add(CreateLane("stackCanvas2", "ONLINE", 50, darkColor, 120, childCollec));


            childCollec = new Collection();
            childCollec.Add(CreateDiagramNode("getmaildetailaboutorder", 100, 40, "white", "Get mail detail\\nabout order", 190, 20, false));
            childCollec.Add(CreateDiagramNode("pakingitem", 100, 40, "white", "Get mail detail\\nabout order", 350, 20, false));
            laneCollection.Add(CreateLane("stackCanvas3", "SHOP", 50, lightColor, 120, childCollec));


            childCollec = new Collection();
            childCollec.Add(CreateDiagramNode("sendcourieraboutaddress", 100, 40, "white", "Send Courier\\n about Address", 190, 20, false));
            childCollec.Add(CreateDiagramNode("deliveryonthataddress", 100, 40, "white", "Delivery on that\\n Address", 350, 20, false));
            childCollec.Add(CreateDiagramNode("getitItem", 100, 40, "white", "GET IT ITEM", 500, 20, true));
            laneCollection.Add(CreateLane("stackCanvas4", "DELIVERY", 50, darkColor, 120, childCollec));

            return laneCollection;
        }

        private Lane CreateLane(string name, string hText, int hWidth, string fillColor, int height, Collection children)
        {
            Lane lane = new Lane();
            lane.Name = name;
            Header header = new Header();
            header.Text = hText;
            header.Width = hWidth;
            header.FillColor = darkColor;
            header.FontSize = 11;
            lane.FillColor = lightColor;
            lane.Header = header;
            lane.Height = height;
            lane.Children = children;
            return lane;
        }

        private void GenerateDiagramConnectors()
        {
            dgrMap.Connectors.Add(GenerateDiagramConnector("connector1", "Order", "selectItemaddcart"));
            dgrMap.Connectors.Add(GenerateDiagramConnector("connector2", "selectItemaddcart", "paymentondebitcreditcard"));
            dgrMap.Connectors.Add(GenerateDiagramConnector("connector3", "paymentondebitcreditcard", "getmaildetailaboutorder"));
            dgrMap.Connectors.Add(GenerateDiagramConnector("connector4", "getmaildetailaboutorder", "pakingitem"));
            dgrMap.Connectors.Add(GenerateDiagramConnector("connector5", "pakingitem", "sendcourieraboutaddress"));
            dgrMap.Connectors.Add(GenerateDiagramConnector("connector6", "sendcourieraboutaddress", "deliveryonthataddress"));
            dgrMap.Connectors.Add(GenerateDiagramConnector("connector7", "deliveryonthataddress", "getitItem"));
        }
        private Connector GenerateDiagramConnector(string name, string sName, string Tname)
        {
            Connector connector = new Connector();
            connector.Name = name;
            connector.SourceNode = sName;
            connector.TargetNode = Tname;
            connector.LineColor = "#606060";
            Decorator decorator = new Decorator();
            decorator.Shape = DecoratorShapes.Arrow;
            decorator.BorderColor = "#606060";
            decorator.Width = 10;
            decorator.Height = 10;
            connector.TargetDecorator = decorator;
            connector.Segments.Add(new Segment() { Type = Segments.Orthogonal });
            return connector;
        }

        private Collection CreatePhases()
        {
            Collection phaseCollec = new Collection();
            phaseCollec.Add(new Phase { Name = "phase1", Offset = 200, LineWidth = 1, LineDashArray = "3,3", LineColor = "#606060", Label = new Syncfusion.JavaScript.DataVisualization.Models.Diagram.Label() { Text = "Phase" } });
            phaseCollec.Add(new Phase { Name = "phase2", Offset = 500, LineWidth = 1, LineDashArray = "3,3", LineColor = "#606060", Label = new Syncfusion.JavaScript.DataVisualization.Models.Diagram.Label() { Text = "Phase" } });

            return phaseCollec;
        }
        private Node CreateDiagramNode(string name, int width, int height, string fillColor, string text, int mLeft, int mTop, bool path)
        {
            BasicShape node = new BasicShape();
            node.Name = name;
            node.Width = width;
            node.Height = height;
            node.FillColor = fillColor;
            node.Labels.Add(new Syncfusion.JavaScript.DataVisualization.Models.Diagram.Label { Text = text, FontSize = 11 });
            if (path)
            {
                node.Shape = BasicShapes.Path;
                node.PathData = "M 120 24.9999 C 120 38.8072 109.642 50 96.8653 50 L 23.135 50 C 10.3578 50 0 38.8072 0 24.9999 L 0 24.9999 C 0 11.1928 10.3578 0 23.135 0 L 96.8653 0 C 109.642 0 120 11.1928 120 24.9999 Z";
            }
            node.MarginLeft = mLeft;
            node.MarginTop = mTop;
            return node;
        }
    }
}