﻿var scrollTop = 0;

// Remove jQuery tooltips.
$(document).ready(function () {

    if (document.getElementById("dgrMap") != null) {
        $.fn.focusWithoutScrolling = function () {
            var x = window.scrollX, y = window.scrollY;
            this.focus();
            window.scrollTo(x, y);
            scrollTop = $(document).scrollTop();
        };
       // $('#dgrMap').focusWithoutScrolling();
        $("#dgrMap").focus(function () {
            var x = window.scrollX, y = scrollTop;
            // this.focus();
            window.scrollTo(x, y);
        });
        $("#dgrMap").mousedown(function (args) {
            event.preventDefault();
            var x = window.scrollX, y = scrollTop;
            this.focus();
            window.scrollTo(x, y);
        });
        $(document).scroll(function () {
            scrollTop = $(document).scrollTop();
        });
        //        $("#dgrMap").bind('mousewheel', function(e, d)  
        //            alert("wheel");
        //        });
        //        $("#CenterArea").bind('mousewheel', function(e, d)  
        //            alert("wheel ca");
        //        });

        //if there is diagram set link and tooltip
        $("#dgrMap_canvas").css("overflow", "hidden");
        var diagram = $("#dgrMap").ejDiagram("instance");
        var title = "";
        for (i = 0; i < diagram.model.nodes.length; i++) {
            var node = $("#" + diagram.model.nodes[i].name);
            var nodeShape = $("#" + diagram.model.nodes[i].name + "_shape");
            var nodeLblText = $("#" + diagram.model.nodes[i].name + "_text_lblbg");
            var nodeLblTitle = $("#" + diagram.model.nodes[i].name + "_title_lblbg");
            if (!(typeof diagram.model.nodes[i].addInfo.title === "undefined")) {
                title = diagram.model.nodes[i].addInfo.title.toString();
                node.attr("title", title);
            }
            if (!(typeof diagram.model.nodes[i].addInfo.url === "undefined") && diagram.model.nodes[i].addInfo.url != "") {
                nodeShape.attr("class", "nodewithlink");
                nodeLblText.attr("class", "nodewithlink");
                nodeLblTitle.attr("class", "nodewithlink");
            }
            diagram.selectionList.length = 0;
            diagram.selectionList.push(node);
            diagram.bringToFront();
        }
        //qTip_init();
        newfitMap();
        $(window).resize(function () { newfitMap(); });

        $('g[title]').qtip(
	{
	    content: {
	        attr: 'title' // Use the title attribute of the area map for the content
	    },
	    show: tooltipShowParams,
	    position: tooltipLeft,
	    style: tooltipStyleParams
	});
	newfitMap();

    }

});

// Fits the new map to the container.
// Fits the new map to the container.
function newfitMap() {
    var elem = document.getElementById("CenterArea");

    var swidth1 = $(window).width() - lOffset - rOffset;
    var sheight1 = $(window).height() - tOffset - bOffset - 68;
    elem.style.width = swidth1 + "px";
    elem.style.height = sheight1 + "px";
    if (swidth1 > maxWidth)
        swidth1 = maxWidth;
    if (swidth1 < minWidth)
        swidth1 = minWidth;
    if (swidth1 >= minWidth) {
        var diagram = $("#dgrMap").ejDiagram("instance");
        var elem = document.getElementById(pnlContId);
        // alert(elem.id);

        elem.style.width = swidth1 + "px";
        // elem.style.height = (mapHeight / maxWidth) * swidth1 + "px";
        elem.style.height = sheight1 + "px";
        // diagram.height = elem.style.height;
        //alert(diagram.height);
        diagram.fitToPage("width", "pageSettings", { "left": 15, "top": 15, "right": 0, "bottom": 15 });
        //        $("#dgrMap_canvas").css("height", elem.style.height);
        // $("#dgrMap_canvas").css("width", elem.style.width);
        //      $("#dgrMap_canvas_svg").attr("height", elem.style.height);
    }
}

function dgrMap_click(args) {
    var url = "";
    if (args.element.shape && !editMode) {
        if (!(typeof args.element.addInfo.url === "undefined") && args.element.addInfo.url != "") {
            url = args.element.addInfo.url.toString();
            if (window.event.ctrlKey)
                window.open(url);
            else 
                window.location.href = url;
            

        }
    }
}

//generate and protocol map
function OnGenerateVectorialMap(documentCode, culture, title, protocol) {
    var diagram = $("#dgrMap").ejDiagram("instance");
    var svg = $("#dgrMap_canvas_svg");
    imgData = diagram.exportDiagram({
        region: "content", format: "jpg", mode: "data"
    });        
    var blob = dataURItoBlob(imgData, "jpg");

    disableUI();
    PIKR.WServices.Documents.GenerateAndProtocolTreeGraph(documentCode, blob, culture, title, protocol, genComplete, onError);
}

//for generate and protocol map
function dataURItoBlob(imgData, imgType) {
    var binary = atob(imgData.split(',')[1]), array = [];
    for (var i = 0; i < binary.length; i++)
        array.push(binary.charCodeAt(i));
    return array;
}

function OnGenerateImgMap() {

}

function genComplete(res) {
    // handle errors
    if (!res.Success) {
        enableUI();

        alert(res.ErrMessage);
        return;
    }
    enableUI();
    if (!res.Protocol) { // just generation, shows the file

        // following code comes from http://stackoverflow.com/questions/16245767/creating-a-blob-from-a-base64-string-in-javascript
        var byteCharacters = atob(res.DocStream);
        var byteNumbers = new Array(byteCharacters.length);
        for (var i = 0; i < byteCharacters.length; i++) {
            byteNumbers[i] = byteCharacters.charCodeAt(i);
        }

        var blob = new Blob([new Uint8Array(byteNumbers)], { type: res.MimeType });

        // from FileSaver.js
        saveAs(blob, res.FileName);
    }
}

// WS call error handler
function onError(err) {
    enableUI();

    if (document.getElementById('Admin').value == 'true')
        alert(getUIResourceString('Resources.Errors.ServerError') + '\n\n---\n\n' + err._message + '\n\n---\n\n' + err._stackTrace);
    else
        alert(getUIResourceString('Resources.Errors.ServerError'));
}

function refreshDiagram(selId) {
    var selDiagram = $('#ddlDiagram').val();
    var selLeaves = $('#ddlLeaves').val();
    var firstLevelSpacing = $('#txtfirstLevelSpacing').val();
    var sublevelsNumber = $('#txtsublevelsNumber').val();
    var firstLevelRootSpacing = $('#txtfirstLevelRootSpacing').val();
    // var selKey = $('#' + selId).val();
   // alert(selKey);
    __doPostBack(selId, selDiagram.toString() + '|' + selLeaves.toString() + '|' + firstLevelSpacing + '|' + sublevelsNumber + '|' + firstLevelRootSpacing);
}

function blockDiagram(btnId) {
    var diagram = $("#dgrMap").ejDiagram("instance");
    var json = diagram.save();
    $("#hdfDiagram").val(JSON.stringify(json));
    __doPostBack(btnId, 'BlockDiagram');
}

function editDiagram(btnId) {
    __doPostBack(btnId, 'EditDiagram');
}

function downloadXML(btnId) {
    __doPostBack(btnId, 'downloadXML');
}

function mapTool(btnId) {
    var url = mapToolUrl;
    window.open(url);
}

function showAlternativelyLabel(btnId) {
    __doPostBack(btnId, 'showaltlabel');
}

function hideAlternativelyLabel(btnId) {
    __doPostBack(btnId, 'showoriginal');
}
